#include <iostream>
#include <queue>
#include <algorithm>
#include <vector>

using namespace std;

bool compare(int* a1, int* a2) {
    if (a1[4] == a2[4])
        return a1[5] > a2[5];
    return a1[4] < a2[4];
}

int k;
int mp, mf, ms, mv;
int minCost = -1;
int costSum = 0;
int minNutsum = 0;
int tempNutsum = 0;
bool* isVisit;
vector<int> inglist;
vector<int> templist;

void func(int** ingred, int current, int start) {
    if (mp <= 0 && mf <= 0 && ms <= 0 && mv <= 0) {
        if (minCost == -1 || (minCost > costSum)) {
            minNutsum = 0;
            inglist.clear();
            for (int i = 0; i < k; i++) {
                if (isVisit[i]) {
                    inglist.push_back(ingred[i][6]);
                    minNutsum += ingred[i][5];
                    sort(inglist.begin(), inglist.end());
                }
            }
            minCost = costSum;
        }
        else if (minCost == costSum) {
            templist.clear();
            tempNutsum = 0;
            for (int i = 0; i < k; i++) {
                if (ingred[i][5] != 0 && isVisit[i]) {
                    templist.push_back(ingred[i][6]);
                    tempNutsum += ingred[i][5];
                    sort(templist.begin(), templist.end());
                }
            }
            if (minNutsum < tempNutsum) {
                minNutsum = tempNutsum;
                inglist = templist;
            }
            else if (minNutsum == tempNutsum) {
                for (int i = 0; i < inglist.size(); i++) {
                    if (inglist[i] > templist[i]) {
                        inglist = templist;
                        minNutsum = tempNutsum;
                        break;
                    }
                    else if (inglist[i] < templist[i]) {
                        break;
                    }
                }
            }
        }
    }
    else {
        for (int i = start; i < k; i++) {
            if (isVisit[i] == false) {
                if (minCost != -1 && costSum + ingred[i][4] > minCost)
                    break;
                isVisit[i] = true;
                mp -= ingred[i][0];
                mf -= ingred[i][1];
                ms -= ingred[i][2];
                mv -= ingred[i][3];
                costSum += ingred[i][4];
                func(ingred, i, i + 1);
                isVisit[i] = false;
                mp += ingred[i][0];
                mf += ingred[i][1];
                ms += ingred[i][2];
                mv += ingred[i][3];
                costSum -= ingred[i][4];
            }
        }
    }
}

int main()
{
    int** ingred;
    int sp = 0, sf = 0, ss = 0, sv = 0;

    cin >> k >> mp >> mf >> ms >> mv;

    ingred = new int* [k];
    for (int i = 0; i < k; i++) {
        ingred[i] = new int[7];
    }
    isVisit = new bool[k];


    for (int i = 0; i < k; i++) {
        cin >> ingred[i][0] >> ingred[i][1] >> ingred[i][2] >> ingred[i][3] >> ingred[i][4];
        sp += ingred[i][0];
        sf += ingred[i][1];
        ss += ingred[i][2];
        sv += ingred[i][3];
        ingred[i][5] = ingred[i][0] + ingred[i][1] + ingred[i][2] + ingred[i][3];
        ingred[i][6] = i + 1;
        isVisit[i] = false;
    }

    if (mp > sp || mf > sf || ms > ss || mv > sv) {
        cout << 0;
    }
    else {
        sort(ingred, ingred + k, compare);

        func(ingred, -1, 0);

        for (int i = 0; i < inglist.size(); i++) {
            cout << inglist[i] << " ";
        }

    }
}