#include <stdio.h>
#include <string.h>
#include <queue>

using namespace std;

int k;
int me[4], pe[5];
double ie[4];
// p: 0, f: 1, s: 2, v: 3
// from [1][0], [1][1], ... [50][4]
int e[51][5], pack[51], seq[51];
int cnt = 0, sum = 0;
int maxsum = 0, mincost = __INT_MAX__;

void check() {
    sum = 0;
    for (int i = 3; i >= 0; i--) sum += pe[i];

    if (pe[4] < mincost) {
        mincost = pe[4];
        maxsum = sum;
        memcpy(seq, pack, sizeof(pack));
    } else {
        if (maxsum < sum) {
            maxsum = sum;
            memcpy(seq, pack, sizeof(pack));
        } else if (maxsum == sum) {
            int i = 0;
            do {
                if (seq[i] != pack[i]) {
                    if (seq[i] > pack[i]) memcpy(seq, pack, sizeof(pack));
                    return;
                } ++i;
            } while (i < cnt);
        }
    }
}

void myFunc(int x, int ch) {
    if (ch) {
        int i = 3;
        while ((i >= 0) && (pe[i] >= me[i])) i--;
        if (i < 0) {
            check();
            return ;
        } 
    }

    if (x > k) return ;

    if (pe[4] + e[x][4] <= mincost) {  
        for (int i = 3; i >= 0; i--) {
            if ((pe[4] + (me[i] - pe[i]) * ie[i]) > (double)mincost) return;
        }
        for (int i = 4; i >= 0; i--) pe[i] += e[x][i];
        pack[cnt++] = x;
        myFunc(x+1, 1);
        for (int i = 4; i >= 0; i--) pe[i] -= e[x][i];
        pack[--cnt] = 0; 
    }
    myFunc(x+1, 0);
}

int main() {
    scanf("%d", &k);
    scanf(" %d %d %d %d", &me[0], &me[1], &me[2], &me[3]);
    int lim[4] = {0, };
    priority_queue <double> PQ[4];
    for (int i = 1; i <= k; i++) {
        scanf(" %d %d %d %d %d", &e[i][0], &e[i][1], &e[i][2], &e[i][3], &e[i][4]);
        for (int j = 0; j < 4; j++) {
            lim[j] += e[i][j];
            PQ[j].push(e[i][j] / (double)e[i][4]);
        }
    }

    for (int i = 0; i < 4; i++) {
        if (lim[i] < me[i]) {
            printf("0\n"); return 0;
        }
    }

    for (int i = 0; i < 4; i++) {
        ie[i] = 1 / PQ[i].top();
    }

    myFunc(1, 0);

    if (maxsum == 0) {
        printf("0\n");
    } else {
        int i = 0;
        while (seq[i] != 0) printf("%d ", seq[i++]);
    }
}