#include <bits/stdc++.h>
using namespace std;

struct food {
	int idx, pro, fat, car, vit, cost;
};

int K;
food take, sum, rf;
vector<int> S, result;
vector<food> Foods;

bool mycmp(food a, food b) {
	if (a.cost == b.cost) {
		int sum1, sum2;
		sum1 = a.pro + a.fat + a.car + a.vit;
		sum2 = b.pro + b.fat + b.car + b.vit;
		if (sum1 == sum2) { return a.idx < b.idx ? true : false; }
		return sum1 > sum2 ? true : false;
	}
	return a.cost < b.cost ? true : false;
}

bool over_take(food f) {
	return (f.pro >= take.pro) &&
		   (f.fat >= take.fat) &&
		   (f.car >= take.car) &&
		   (f.vit >= take.vit);
}

int read() {
	int idx = 1;
	food f, s;
	vector<int> v;
	cin >> K;
	cin >> take.pro >> take.fat >> take.car >> take.vit;

	for(int i = 0; i < K; i++) {
		f.idx = idx++;
		cin >> f.pro >> f.fat >> f.car >> f.vit >> f.cost;
		Foods.push_back(f);
	}
	sort(Foods.begin(), Foods.end(), mycmp);

	s.idx = 0; s.pro = 0; s.fat = 0; s.car = 0; s.vit = 0; s.cost = 0;
	for(auto f : Foods) {
		v.push_back(f.idx);
		s.pro += f.pro; s.fat += f.fat; s.car += f.car;
		s.vit += f.vit; s.cost += f.cost;

		if (over_take(s)) {
			if (v.size() == K) { return 1; }
			rf = s;
			result = v;
			sort(result.begin(), result.end());
			return 2;
		}
	}
	return 0;
}

void cmp_result() {
	if (sum.cost == rf.cost) {
		int s1, s2;
		s1 = sum.pro + sum.fat + sum.car + sum.vit;
		s2 =  rf.pro +  rf.fat +  rf.car +  rf.vit;
		if (s1 == s2) {
			for(int i = 0; i < S.size() && i < result.size(); i++) {
				if (S.at(i) < result.at(i)) {
					rf = sum; result = S;
					return;
				}
			}
			if (S.size() < result.size()) { rf = sum; result = S; }
		}
		else if (s1 > s2) {	rf = sum; result = S; }
	}
	else if (sum.cost < rf.cost) { rf = sum; result = S; }
}

void operating(int n) {
	if (n == K) { return; }
	food f = Foods.at(n);
	if (sum.cost + f.cost > rf.cost) { return; }
	sum.pro += f.pro; sum.fat += f.fat; sum.car += f.car;
	sum.vit += f.vit; sum.cost += f.cost;
	S.push_back(f.idx);
	if (over_take(sum)) {
		cmp_result();
		S.pop_back();
		sum.pro -= f.pro; sum.fat -= f.fat; sum.car -= f.car;
		sum.vit -= f.vit; sum.cost -= f.cost;
	}
	else {
		operating(n + 1);
		sum.pro -= f.pro; sum.fat -= f.fat; sum.car -= f.car;
		sum.vit -= f.vit; sum.cost -= f.cost;
		S.pop_back();
		operating(n + 1);
	}
}

void outcome() {
	sort(result.begin(), result.end());
	for(auto i : result) { cout << i << " "; }
}

int main() {
	ios_base::sync_with_stdio(false);
	cin.tie(NULL);
	cout.tie(NULL);
	int r = read();
	if (r == 0) { cout << 0; }
	else if (r == 1) { outcome(); }
	else {
		operating(0);
		outcome();
	}
	return 0;
}